package com.muzhi.meidiai.service.impl;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceResponse;
import com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsResponse;
import com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationNoTableFieldResponse;
import com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationResponse;
import com.aliyun.dingtalkyida_1_0.models.SearchFormDatasResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiAttendanceListRequest;
import com.dingtalk.api.response.OapiAttendanceListResponse;
import com.muzhi.meidiai.service.AccessTokenService;
import com.muzhi.meidiai.service.DingOaService;
import com.taobao.api.ApiException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


@Service
@Slf4j
public class DingOaServiceImpl implements DingOaService {

    @Autowired
    private AccessTokenService accessTokenService;

    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    //获取宜搭审批实例详情（项目预算档案-根据项目负责人id判断）
    @Override
    public List getXiangMuXX(String userid){
        System.out.println("连接器传参过来的项目负责人id：" + userid);

        //list集合装载最终的集合
        List list = new ArrayList();

        JSONObject jsonObject = null;

        int size = 100;
        int page = 1;

        do {
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders searchFormDatasHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders();
                searchFormDatasHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest searchFormDatasRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest()
                        //宜搭应用秘钥
                        .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                        //每页查询数量
                        .setPageSize(size)
                        //当前分页
                        .setCurrentPage(page)
                        //宜搭表单ID
                        .setFormUuid("FORM-CP766081DPN573HYBQCWJADYI6SB232G0RKALL")
                        //TODO 系统管理员id
                        .setUserId("yida_pub_account")
                        //宜搭应用编码
                        .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D");

                SearchFormDatasResponse searchFormDatasResponse = client.searchFormDatasWithOptions(searchFormDatasRequest, searchFormDatasHeaders, new RuntimeOptions());
                System.out.println(JSON.toJSONString(searchFormDatasResponse.getBody()));
                String s = JSON.toJSONString(searchFormDatasResponse.getBody());
                jsonObject = JSON.parseObject(s);
                System.out.println("审批详情接口object对象：" + jsonObject);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            JSONArray data = jsonObject.getJSONArray("data");
            for (int i = 0; data.size()>i; i++){

                Map map = new HashMap();

                JSONObject formData = data.getJSONObject(i).getJSONObject("formData");

                String xmbh = formData.getString("textField_lakr1jwy");
                System.out.println("项目编号：" + xmbh);

                String xmmc = formData.getString("textField_lajb96s9");
                System.out.println("项目名称：" + xmmc);

                String xmfzrid = formData.getString("textField_lbf3y926");
                System.out.println("项目负责人id：" + xmfzrid);

                String xmfzrmc = formData.getString("textField_lbf3y925");
                System.out.println("项目负责人名称：" + xmfzrmc);
//
                String jsdzt = formData.getString("selectField_lbf3y920");
                System.out.println("结算单状态：" + jsdzt);

//            if (jsdzt.equals("已结算")){
//                System.out.println("项目已结算，不加载！");
//            }else {
                map.put("xmbh", xmbh);
                map.put("xmmc", xmmc);
                map.put("xmfzrid", xmfzrid);
                map.put("xmfzrmc", xmfzrmc);
                System.out.println("根据表单发起人id创建的map集合：" + map);
                list.add(map);
//            }

//            int result = xmfzrid.indexOf(userid);
//            if (result == -1){//xmfzrid.equals(userid)
//                System.out.println("项目人员id控件不包含当前人员userid：" + "-1代表不包含" + result);
//            }else {
//                map.put("xmbh", xmbh);
//                map.put("xmmc", xmmc);
////                map.put("xmfzrid", xmfzrid);
////                map.put("xmfzrmc", xmfzrmc);
//                System.out.println("根据表单发起人id创建的map集合：" + map);
//                list.add(map);
//            }
            }

            if (data.size() == 100){
                page = page + 1;
            }

//            float aa = jsonObject.getFloat("totalCount") / 100;
//            int bb = jsonObject.getInteger("currentPage");
//            log.info("aa" + aa + "---bb" + bb);
        }while (jsonObject.getFloat("totalCount") / 100 > jsonObject.getInteger("currentPage"));


        System.out.println("list集合：" + list);

        return list;
    }

    //获取宜搭审批实例详情（项目预算档案-根据连接器加载的项目列表选择某个项目时，加载项目编号、项目名称、项目负责人id、项目负责人名称到指定控件中）；【外出、加班】使用。
    @Override
    public String getXiangMuID(String xmid){
        System.out.println("连接器传参过来的项目id：" + xmid);

        //list集合装载最终的集合
        List list = new ArrayList();

        JSONObject jsonObject = null;

        int size = 100;
        int page = 1;

        do {
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders searchFormDatasHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders();
                searchFormDatasHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest searchFormDatasRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest()
                        //宜搭应用秘钥
                        .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                        //每页查询数量
                        .setPageSize(size)
                        //当前分页
                        .setCurrentPage(page)
                        //宜搭表单ID
                        .setFormUuid("FORM-CP766081DPN573HYBQCWJADYI6SB232G0RKALL")
                        //TODO 系统管理员id
                        .setUserId("yida_pub_account")
                        //宜搭应用编码
                        .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D");

                SearchFormDatasResponse searchFormDatasResponse = client.searchFormDatasWithOptions(searchFormDatasRequest, searchFormDatasHeaders, new RuntimeOptions());
                System.out.println(JSON.toJSONString(searchFormDatasResponse.getBody()));
                String s = JSON.toJSONString(searchFormDatasResponse.getBody());
                jsonObject = JSON.parseObject(s);
                System.out.println("审批详情接口object对象：" + jsonObject);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            JSONArray data = jsonObject.getJSONArray("data");
            for (int i = 0; data.size()>i; i++){

                Map map = new HashMap();

                JSONObject formData = data.getJSONObject(i).getJSONObject("formData");

                String xmbh = formData.getString("textField_lakr1jwy");
                System.out.println("项目编号：" + xmbh);

                String xmmc = formData.getString("textField_lajb96s9");
                System.out.println("项目名称：" + xmmc);

                String xmfzrid = formData.getString("textField_lbf3y926");
                System.out.println("项目负责人id：" + xmfzrid);

                String xmfzrmc = formData.getString("textField_lbf3y925");
                System.out.println("项目负责人名称：" + xmfzrmc);
//
//            String jsdzt = formData.getString("selectField_lbf3y920");
//            System.out.println("结算单状态：" + jsdzt);

                if (xmbh.equals(xmid)){
                    map.put("xmbh", xmbh);
                    map.put("xmmc", xmmc);
                    map.put("xmfzrid", xmfzrid);
                    map.put("xmfzrmc", xmfzrmc);
                    //延时类型
                    if (xmmc.equals("公司延时")){
                        map.put("yslx","公司延时");
                    }else {
                        map.put("yslx","项目延时");
                    }
                    System.out.println("根据表单选择项目列表的项目id创建的map集合：" + map);
                    list.add(map);
                }
            }

            if (data.size() == 100){
                page = page + 1;
            }
        }while (jsonObject.getFloat("totalCount") / 100 > jsonObject.getInteger("currentPage"));

        String s = JSON.toJSONString(list);
        System.out.println("list集合（转字符型）：" + s);

        JSONObject jsonObjectR = JSON.parseArray(s).getJSONObject(0);
        System.out.println("返回对象：" + jsonObject);
        String s1 = jsonObjectR.toJSONString();
        System.out.println("返回对象转jsonString：" + s1);

        return s1;
    }

    //OA审批表单提交校验：判断当前离职审批发起人在宜搭中是否存在未结算项目，如有，则审批不通过，并弹窗提示：当前有未结算项目，请完成项目交接！
    @Override
    public Map getXiangMuJY(String userid){
        System.out.println("连接器传传参过来的项目负责人id：" + userid);

        Boolean zhi = null;

        int jsdztAll = 0;

        JSONObject jsonObject = null;

        try {
            com.aliyun.dingtalkyida_1_0.Client client = createClient();
            com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders searchFormDatasHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasHeaders();
            searchFormDatasHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest searchFormDatasRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDatasRequest()
                    //宜搭应用秘钥
                    .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                    //每页查询数量
                    .setPageSize(100)
                    //当前分页
                    .setCurrentPage(1)
                    //宜搭表单ID
                    .setFormUuid("FORM-CP766081DPN573HYBQCWJADYI6SB232G0RKALL")
                    //TODO 系统管理员id
                    .setUserId("yida_pub_account")
                    //宜搭应用编码
                    .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D");

            SearchFormDatasResponse searchFormDatasResponse = client.searchFormDatasWithOptions(searchFormDatasRequest, searchFormDatasHeaders, new RuntimeOptions());
            System.out.println(JSON.toJSONString(searchFormDatasResponse.getBody()));
            String s = JSON.toJSONString(searchFormDatasResponse.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("审批详情接口object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        JSONArray data = jsonObject.getJSONArray("data");
        for (int i = 0; data.size()>i; i++){

            JSONObject formData = data.getJSONObject(i).getJSONObject("formData");

            String xmbh = formData.getString("textField_lakr1jwy");
            System.out.println("项目编号：" + xmbh);

            String xmmc = formData.getString("textField_lajb96s9");
            System.out.println("项目名称：" + xmmc);

            String xmfzrid = formData.getString("textField_lbf3y926");
            System.out.println("项目负责人id：" + xmfzrid);

            String xmfzrmc = formData.getString("textField_lbf3y925");
            System.out.println("项目负责人名称：" + xmfzrmc);

            String jsdzt = formData.getString("selectField_lbf3y920");
            System.out.println("结算单状态：" + jsdzt);

//            if (xmfzrid.equals(userid) && jsdzt.equals("未结算")){
//                jsdztAll = jsdztAll + 1;
//            }

            int result = xmfzrid.indexOf(userid);
            if (result == -1){
                System.out.println("项目人员id控件不包含当前人员userid：" + "-1代表不包含" + result);
            }else if (result != -1 && jsdzt.equals("未结算")){
                jsdztAll = jsdztAll + 1;
            }
        }
        System.out.println("当前提交人在宜搭项目信息档案中的结算单状态属于【未结算】的单数：" + jsdztAll);

        //可以比对字符型
//        if (processid.equals("测试")){
//            zhi = true;
//        }else {
//            zhi = false;
//        }

        if (jsdztAll == 0){
            zhi = true;
        }else {
            zhi = false;
        }
        System.out.println("校验结果：" + zhi);

        Map map = new HashMap();
        map.put("jiaoyanjieguo", zhi);
        map.put("jiaoyanxinxi","当前有未结算项目，请完成项目交接！");

        return map;
    }

    //OA【加班】审批表单提交校验：判断当前审批发起人提交【加班】时间是否跨天提交，如有，则审批不通过，并弹窗提示：不能跨天提交！
    @Override
    public Map getTimeJY(String startTime,String endTime){
        System.out.println("连接器传传参过来的开始时间：" + startTime);
        System.out.println("连接器传传参过来的结束时间：" + endTime);

        //计算加班开始日期后一天的早上7点的时间
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        Date date = null;
        try {
            date = dateFormat.parse(startTime);
        }catch (Exception e){
            e.printStackTrace();
        }
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        //加班结束时间后一天早上七点钟
        calendar.add(Calendar.DAY_OF_MONTH,1);
        calendar.set(Calendar.HOUR_OF_DAY,7);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        calendar.set(Calendar.MILLISECOND,0);
        String time = new SimpleDateFormat("yyyy-MM-dd HH:mm").format(calendar.getTime());
        System.out.println("前一天零点：" + time);
        Date dateJiaoyan = null;
        try {
            dateJiaoyan = dateFormat.parse(time);
        }catch (Exception e){
            e.printStackTrace();
        }

        //实际选择加班结束时间
        Date dateEnd = null;
        try {
            dateEnd = dateFormat.parse(endTime);
        }catch (Exception e){
            e.printStackTrace();
        }

        Boolean zhi = null;

        //判断两个时间是否为同一天
//        DateTime startTimeParse = DateUtil.parse(startTime);
//        DateTime endTimeParse = DateUtil.parse(endTime);
//        boolean sameDay = DateUtil.isSameDay(startTimeParse, endTimeParse);

//        if (sameDay == true){
//            zhi = true;
//        }else {
//            zhi = false;
//        }

        if (dateEnd.before(dateJiaoyan) == true){
            zhi = true;
        }else {
            zhi = false;
        }
        System.out.println("校验结果：" + zhi);

        Map map = new HashMap();
        map.put("jiaoyanjieguo", zhi);
        map.put("jiaoyanxinxi","不能跨天提交！");

        return map;
    }

    /*
     * 保存宜搭表单数据【加班信息档案】
     * */
    @Override
    public String createJBXX(String jbrid,
                             String kssj, String jssj,String jbsc,
                             String xmbh, String xmmc,
                             String jbsy, String djbh){

        System.out.println("创建人员ID（钉钉ID）：" + jbrid +
                "开始时间：" + kssj + "结束时间：" + jssj + "加班时长：" + jbsc +
                "项目编号：" + xmbh + "项目名称：" + xmmc +
                "加班事由：" + jbsy + "单据编号：" + djbh);

        //将连接器传参过来的创建时间字符串转成毫秒级时间戳
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        //创建时间（转毫秒级时间戳）
        long timeCJ = new Date().getTime();
        System.out.println("创建时间毫秒级时间戳：" + timeCJ);

        //开始时间（转毫秒级时间戳）
        long timeStart = 0;
        try {
            Date date = simpleDateFormat.parse(kssj);
            timeStart = date.getTime();
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("开始时间毫秒级时间戳：" + timeStart);

        //结束时间（转毫秒级时间戳）
        long timeEnd = 0;
        try {
            Date date = simpleDateFormat.parse(jssj);
            timeEnd = date.getTime();
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("结束时间毫秒级时间戳：" + timeEnd);

        Map map = new HashMap();
        //创建人员ID（钉钉ID）
        map.put("employeeField_laji1ktx", jbrid);
        //创建时间（时间戳）
        map.put("dateField_laji1ktz", timeCJ);
        //开始时间（时间戳）
        map.put("dateField_laji1ku4", timeStart);
        //结束时间（时间戳）
        map.put("dateField_laji1ku5", timeEnd);
        //加班时长
        map.put("numberField_laji1ku6", jbsc);
        //项目编号
        map.put("textField_laji1kub", xmbh);
        //项目名称
        map.put("textField_laji1kuc", xmmc);
        //项目负责人id（钉钉ID）
//        map.put("employeeField_laji1kud", xmfzrid);
        //加班事由
        map.put("textField_laji1kuj", jbsy);
        //单据编号
        map.put("textField_laji1ktr",djbh);
        //报销状态
        map.put("selectField_lbdkq8rj","未报销");

        String mapJson = JSON.toJSONString(map);
        System.out.println("mapJson：" + mapJson);

        try {
            com.aliyun.dingtalkyida_1_0.Client client = createClient();
            com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders saveFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders();
            saveFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest saveFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest()
                    //宜搭应用秘钥
                    .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                    //宜搭表单ID
                    .setFormUuid("FORM-6W9667D1HHP5NWQV9W7VQ6S9NQ7W3Z530IJAL1")
                    //创建人id
                    .setUserId(jbrid)
                    //宜搭应用编码
                    .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D")
                    .setFormDataJson(mapJson);

            client.saveFormDataWithOptions(saveFormDataRequest, saveFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
        return "【宜搭】创建加班信息档案成功！";
    }

    //OA【加班】审批表单提交校验：判断当前审批发起人提交【加班】中关联的项目（编号）是否提交过审批（包含已提交、撤销、拒绝），
    // 如有，则审批不通过，并弹窗提示：当前项目你已提交过加班！
    public static com.aliyun.dingtalkworkflow_1_0.Client createClient1() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkworkflow_1_0.Client(config);
    }

    @Override
    public Map getXiangMuIsNullJY(String userid,String xmbh,String startTime,String endTime){
        System.out.println("连接器传传参过来的人员id：" + userid);
        System.out.println("连接器传传参过来的项目（编号）：" + xmbh);
        System.out.println("连接器传传参过来的加班（开始）时间：" + startTime);
        System.out.println("连接器传传参过来的加班（开始）时间：" + endTime);


        //牧之011033176057927940
        //燕江09535801661638954621
//        userid = "011033176057927940";
//        xmbh = "XM002";

        //记录当前人员当日提交的加班审批中选择的项目（编号）是否已经提交过审批单【计数】
        int a = 0;

        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        Date dateStart = null;
        try {
            dateStart = dateFormat.parse(startTime);
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("dateStart：" + dateStart);
        long timeStart = dateStart.getTime();
        System.out.println("加班开始时间（毫秒级时间戳）：" + timeStart);

        Date dateEnd = null;
        try {
            dateEnd = dateFormat.parse(endTime);
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("dateEnd：" + dateEnd);
        long timeEnd = dateStart.getTime();
        System.out.println("加班结束时间（毫秒级时间戳）：" + timeEnd);



//        Date date = new Date();

//        Calendar calendar = Calendar.getInstance();
//        calendar.setTime(date);
//        calendar.set(Calendar.HOUR_OF_DAY,0);
//        calendar.set(Calendar.MINUTE,0);
//        calendar.set(Calendar.SECOND,0);
//        calendar.set(Calendar.MILLISECOND,0);
//        String FORMtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
//        System.out.println("当天零点（时间型）：" + FORMtime);
//
//        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//        Date dateFORM = null;
//        try {
//            dateFORM = simpleDateFormat.parse(FORMtime);
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        long timeStart = dateFORM.getTime();
//        System.out.println("当天零点（毫秒级时间戳）：" + timeStart);

//        calendar.setTime(date);
//        calendar.set(Calendar.HOUR_OF_DAY,23);
//        calendar.set(Calendar.MINUTE,59);
//        calendar.set(Calendar.SECOND,59);
//        calendar.set(Calendar.MILLISECOND,0);
//        String TOtime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
//        System.out.println("当天24点：" + TOtime);
//
//        Date dateTO = null;
//        try {
//            dateTO = simpleDateFormat.parse(TOtime);
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        long timeEnd = dateTO.getTime();
//        System.out.println("当天24点（毫秒级时间戳）：" + timeEnd);

        JSONObject jsonObject = null;
        try {
            com.aliyun.dingtalkworkflow_1_0.Client client = createClient1();
            com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsHeaders listProcessInstanceIdsHeaders = new com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsHeaders();
            listProcessInstanceIdsHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsRequest listProcessInstanceIdsRequest = new com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsRequest()
                    //查询当天开始时间（毫米级时间戳）
                    .setStartTime(timeStart)
                    //查询当天结束时间（毫米级时间戳）
                    .setEndTime(timeEnd)
                    //加班审批单的processCode
                    .setProcessCode("PROC-613F4AE2-48B6-45D1-985F-D60B7A3EDD26")
                    .setNextToken(0L)
                    .setMaxResults(20L)
                    //待查询人员id
                    .setUserIds(java.util.Arrays.asList(userid));
            ListProcessInstanceIdsResponse listProcessInstanceIdsResponse = client.listProcessInstanceIdsWithOptions(listProcessInstanceIdsRequest, listProcessInstanceIdsHeaders, new RuntimeOptions());
            System.out.println(JSON.toJSONString(listProcessInstanceIdsResponse.getBody()));
            String s = JSON.toJSONString(listProcessInstanceIdsResponse.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("审批实例ID列表接口object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        JSONArray jsonArray = jsonObject.getJSONObject("result").getJSONArray("list");
        if (!jsonArray.isEmpty()){
            for (int i = 0; i < jsonArray.size(); i++) {
                String string = jsonArray.getString(i);
                System.out.println("循环获取审批实例id：" + string);
                //获取审批实例详情
                try {
                    com.aliyun.dingtalkworkflow_1_0.Client client = createClient1();
                    com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders getProcessInstanceHeaders = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders();
                    getProcessInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                    com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest getProcessInstanceRequest = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest()
                            //审批实例id
                            .setProcessInstanceId(string);
                    GetProcessInstanceResponse processInstanceWithOptions = client.getProcessInstanceWithOptions(getProcessInstanceRequest, getProcessInstanceHeaders, new RuntimeOptions());
                    System.out.println(JSON.toJSONString(processInstanceWithOptions.getBody()));
                    String s = JSON.toJSONString(processInstanceWithOptions.getBody());
                    jsonObject = JSON.parseObject(s);
                    System.out.println("审批实例详情接口object对象：" + jsonObject);
                } catch (TeaException err) {
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                } catch (Exception _err) {
                    TeaException err = new TeaException(_err.getMessage(), _err);
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                }

                JSONArray jsonArray1 = jsonObject.getJSONObject("result").getJSONArray("formComponentValues");
                //TODO OA审批单接口调用中，11属于项目编号的控件，【注意：不能随意更改表单控件！！！】
                String valueXMBH = jsonArray1.getJSONObject(11).getString("value");
                System.out.println("循环获取审批详情的项目编号：" + valueXMBH);

                if (valueXMBH.equals(xmbh)){
                    a = a + 1;
                }
            }
        }
        System.out.println("记录当前人员当日提交的加班审批中选择的项目（编号）是否已经提交过审批单【计数】：" + a);

        Boolean zhi = null;

        if (a == 0){
            zhi = true;
        }else {
            zhi = false;
        }
        System.out.println("校验结果：" + zhi);

        Map map = new HashMap();
        map.put("jiaoyanjieguo", zhi);
        map.put("jiaoyanxinxi","当前加班日期该项目你已提交过加班！");

        return map;
    }

    /*
     * 抓取钉钉出差外勤打卡信息更新至宜搭【出差明细中间表】
     * 出差开始日期、出差结束日期、出差天数、出差补贴（结合岗位补贴标准字段*出差天数）
     * */
    @Override
    public String updateChuchaiA(){

        /*查询宜搭【出差明细中间表】符合（同步状态=未同步）的单据*/
        JSONObject jsonObject = null;

        int size = 100;
        int page = 1;

        do {
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationNoTableFieldHeaders searchFormDataSecondGenerationNoTableFieldHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationNoTableFieldHeaders();
                searchFormDataSecondGenerationNoTableFieldHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationNoTableFieldRequest searchFormDataSecondGenerationNoTableFieldRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationNoTableFieldRequest()
                        .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                        .setFormUuid("FORM-RK966E71VZU5Y4NGCETV6DT8JUEL3I97XZ2BL4")
                        //每页条数，最大100条
                        .setPageSize(size)
                        //当前页码，默认从1开始
                        .setPageNumber(page)
                        //TODO 系统管理员id
                        .setUserId("yida_pub_account")
                        .setSearchCondition("[{  \"key\": \"textField_lbdex822\",  \"value\": \"未同步\",  \"type\": \"TEXT\",  \"operator\": \"eq\",  \"componentName\": \"TextField\" }]")
                        .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D");

                SearchFormDataSecondGenerationNoTableFieldResponse searchFormDataSecondGenerationNoTableFieldResponse = client.searchFormDataSecondGenerationNoTableFieldWithOptions(searchFormDataSecondGenerationNoTableFieldRequest, searchFormDataSecondGenerationNoTableFieldHeaders, new RuntimeOptions());
                System.out.println(JSON.toJSONString(searchFormDataSecondGenerationNoTableFieldResponse.getBody()));
                String s = JSON.toJSONString(searchFormDataSecondGenerationNoTableFieldResponse.getBody());
                jsonObject = JSON.parseObject(s);
                System.out.println("【出差明细中间表】实例详情接口object对象：" + jsonObject);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            JSONArray data = jsonObject.getJSONArray("data");
            for (int i = 0; i < data.size(); i++) {
                //================出差人员id================
                String employeeField_lajb96ub_id = data.getJSONObject(i).getJSONObject("formData").getJSONArray("employeeField_lajb96ub_id").getString(0);
                System.out.println("出差人员id：" + employeeField_lajb96ub_id);

                //================审批实例id================
                String formInstanceId = data.getJSONObject(i).getString("formInstanceId");
                System.out.println("审批实例id：" + formInstanceId);

                //================同步状态================
                String textField_lbdex822 = data.getJSONObject(i).getJSONObject("formData").getString("textField_lbdex822");
                System.out.println("同步状态：" + textField_lbdex822);

                //================岗位补助标准================
                int numberField_lajb96um = data.getJSONObject(i).getJSONObject("formData").getInteger("numberField_lajb96um");
                System.out.println("岗位补助标准：" + numberField_lajb96um);

                SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                //================出差开始时间（毫秒级时间戳）================
                String dateField_lajb96ud = data.getJSONObject(i).getJSONObject("formData").getString("dateField_lajb96ud");
                System.out.println("出差开始时间（毫秒级时间戳）：" + dateField_lajb96ud);
                long startLong = new Long(dateField_lajb96ud);
                //将时间戳转换为时间
                Date startDate = new Date(startLong);
                System.out.println("出差开始时间（时间型）：" + startDate);
                //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
                String startString = simpleDateFormat.format(startDate);
                System.out.println("出差开始时间（时间样式）：" + startString);

                //================出差结束时间（毫秒级时间戳）================
                String dateField_lajb96uf = data.getJSONObject(i).getJSONObject("formData").getString("dateField_lajb96uf");
                System.out.println("出差结束时间（毫秒级时间戳）：" + dateField_lajb96uf);
                long endLong = new Long(dateField_lajb96uf);
                //将时间戳转换为时间
                Date endDate = new Date(endLong);
                System.out.println("出差结束时间（时间型）：" + endDate);
                //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
                String endString = simpleDateFormat.format(endDate);
                System.out.println("出差结束时间（时间样式）：" + endString);

                //================当前时间================
                Date dateNow = new Date(System.currentTimeMillis());
                System.out.println("当前时间（时间型）：" + dateNow);
                String dateNowString = simpleDateFormat.format(dateNow);
                System.out.println("当前时间（时间样式）：" + dateNowString);

                //================获取出差结束时间后面一天的零点零分零秒================
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(endDate);
                //后面一天
                calendar.add(Calendar.DAY_OF_MONTH, 1);
                calendar.set(Calendar.HOUR_OF_DAY, 6);
                calendar.set(Calendar.MINUTE, 0);
                calendar.set(Calendar.SECOND, 0);
                calendar.set(Calendar.MILLISECOND, 0);
                String lastTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
                System.out.println("出差结束时间后面一天早上6点：" + lastTime);

                //================时间比对================
                //当前时间
                DateTime parseA = DateUtil.parse(dateNowString);
                //出差结束时间后面一天
                DateTime parseB = DateUtil.parse(lastTime);
//                //比对两个时间是否属于同一天，属于为true,反之为false
//                boolean sameDay = DateUtil.isSameDay(parseA, parseB);
//                System.out.println("时间比对结果：" + sameDay);
                //比对两个时间大小，当前时间如果大于未同步单据的出差后一天凌晨6点的时间的话，则会执行查询考勤打卡情况
                boolean after = parseA.after(parseB);
                System.out.println("时间大小比对结果（当前时间是否大于未同步单据的出差后一天凌晨6点的时间）：" + after);

                //================时间相等（满足执行时间）则去抓取该人员的考勤打卡数据，并将出勤结果同步更新至宜搭================
                if (after == true) {
                    //出差实际总天数
                    int ccts = 0;

                    /*查询指定出差申请日期的人员的钉钉考勤打卡*/
                    //待查询人员userid
                    List list = new ArrayList();
                    list.add(employeeField_lajb96ub_id);

                    String body = null;
                    String errmsg = null;
                    try {
                        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/attendance/list");
                        OapiAttendanceListRequest req = new OapiAttendanceListRequest();
                        //出差开始时间
                        req.setWorkDateFrom(startString);
                        //出差结束时间
                        req.setWorkDateTo(lastTime);
                        //待查询人员userid
                        req.setUserIdList(list);
                        req.setOffset(0L);
                        req.setLimit(50L);
                        OapiAttendanceListResponse rsp = client.execute(req, accessTokenService.getAccessToken());
                        body = rsp.getBody();
                        System.out.println("打卡结果返回：" + body);
                        JSONObject jsonObject1 = JSON.parseObject(body);
                    } catch (ApiException e) {
                        e.printStackTrace();
                    }

                    try {
                        JSONObject jsonObjectA = JSON.parseObject(body);
                        JSONArray recordresult = jsonObjectA.getJSONArray("recordresult");

                        errmsg = jsonObjectA.getString("errmsg");
                        System.out.println("打卡结果返回错误信息：" + errmsg);
                        int dkcs = 0;
                        for (int a = 0; a < recordresult.size(); a++) {
                            //位置结果：判断是否属于Outside：范围外
                            //Normal：范围内
                            //Outside：范围外
                            //NotSigned：未打卡
                            String result = recordresult.getJSONObject(a).getString("locationResult");
                            System.out.println("打卡位置结果：" + result);
                            if (result.equals("Outside")) {
                                dkcs = dkcs + 1;
                            }
                        }
                        dkcs = dkcs / 2;
                        int dkcsLast = (int) dkcs;

                        if (dkcs > 0) {
                            //出差实际总天数
                            ccts = ccts + dkcsLast;
                        }
                        System.out.println("出差实际总天数：" + ccts);

                        //计算实际的出差补助（岗位补贴标准*出差实际总天数）
                        int ccbz = numberField_lajb96um * ccts;
                        System.out.println("实际的出差补助：" + ccbz);

                        Map map = new HashMap();
                        //出差实际总天数
                        map.put("numberField_lc465cyx", ccts);
                        //实际的出差补助
                        map.put("numberField_lc465cyy", ccbz);
                        //同步状态
                        map.put("textField_lbdex822", "已同步");
                        if (dkcs == 0){
                            //同步说明
                            map.put("textField_lemny5eq","打卡记录不存在！");
                        }else if (errmsg.equals("时间跨度太大")){
                            //同步说明
                            map.put("textField_lemny5eq","【errmsg】获取出差打卡记录时间跨度太大！");
                        }else {
                            //同步说明
                            map.put("textField_lemny5eq","已同步打卡记录。");
                        }
                        String mapStr = JSON.toJSONString(map);
                        System.out.println("封装修改的字段参数：" + mapStr);

                        try {
                            com.aliyun.dingtalkyida_1_0.Client client = createClient();
                            com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders updateFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders();
                            updateFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                            com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest updateFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest()
                                    //应用秘钥
                                    .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                                    //表单实例id
                                    .setFormInstanceId(formInstanceId)
                                    //TODO 系统管理员id
                                    .setUserId("yida_pub_account")
                                    //应用id
                                    .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D")
                                    //修改字段
                                    .setUpdateFormDataJson(mapStr);

                            client.updateFormDataWithOptions(updateFormDataRequest, updateFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
                        } catch (TeaException err) {
                            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                                // err 中含有 code 和 message 属性，可帮助开发定位问题
                            }

                        } catch (Exception _err) {
                            TeaException err = new TeaException(_err.getMessage(), _err);
                            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                                // err 中含有 code 和 message 属性，可帮助开发定位问题
                            }

                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }while (jsonObject.getFloat("totalCount") / 100 > jsonObject.getInteger("pageNumber"));

        return "同步【出差明细中间表】完成！";
    }

    /*
     * 抓取钉钉出差外勤打卡信息更新至宜搭【项目预算档案】
     * 出差开始日期、出差结束日期、出差天数、出差补贴（结合岗位补贴标准字段*出差天数）
     * */
    @Override
    public String updateChuchaiB(){

        /*查询宜搭【项目预算档案】[出差明细]中符合（同步状态=未同步）的单据*/
        JSONObject jsonObject = null;
        try {
            com.aliyun.dingtalkyida_1_0.Client client = createClient();
            com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationHeaders searchFormDataSecondGenerationHeaders = new com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationHeaders();
            searchFormDataSecondGenerationHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationRequest searchFormDataSecondGenerationRequest = new com.aliyun.dingtalkyida_1_0.models.SearchFormDataSecondGenerationRequest()
                    .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                    .setFormUuid("FORM-CP766081DPN573HYBQCWJADYI6SB232G0RKALL")
                    .setUserId("yida_pub_account")
                    .setSearchCondition("[{  \"key\": \"tableField_lajb96u9\",  \"value\": \"未同步\",  \"type\": \"TEXT\",  \"operator\": \"contains\",  \"componentName\": \"TableField\" }]")
                    .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D");

            SearchFormDataSecondGenerationResponse searchFormDataSecondGenerationResponse = client.searchFormDataSecondGenerationWithOptions(searchFormDataSecondGenerationRequest, searchFormDataSecondGenerationHeaders, new RuntimeOptions());
            System.out.println(JSON.toJSONString(searchFormDataSecondGenerationResponse.getBody()));
            String s = JSON.toJSONString(searchFormDataSecondGenerationResponse.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("【项目预算档案】实例详情接口object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        JSONArray data = jsonObject.getJSONArray("data");

        for (int i = 0; i < data.size(); i++) {
            log.info("开始抓取宜搭[项目预算档案]的第【" + i + "】条实例数据......");

            //每条实例数据的出差子表
            JSONArray tableField_lajb96u9 = data.getJSONObject(i).getJSONObject("formData").getJSONArray("tableField_lajb96u9");

            //================审批实例id================
            String formInstanceId = data.getJSONObject(i).getString("formInstanceId");
            System.out.println("审批实例id：" + formInstanceId);

            //封装出差明细【全量】
            Map mapA = new HashMap();
            List listA = new ArrayList();
            //最终调整为jsonStr
            String mapAStr = null;

            //出差实际成本
            int cxsjcb = 0;

            //循环获取出差明细表第i条数据中的每个字段信息
            for (int j = 0; j < tableField_lajb96u9.size(); j++) {
                log.info("开始抓取宜搭[项目预算档案][出差明细表]的第【" + j + "】条人员数据......");

                //================出差明细中的人员id================
                String employeeField_lajb96ub_id = tableField_lajb96u9.getJSONObject(j).getJSONArray("employeeField_lajb96ub_id").getString(0);
                System.out.println("出差人员id：" + employeeField_lajb96ub_id);

                //================是否市外出差id================
                String selectField_lajb96un_id = tableField_lajb96u9.getJSONObject(j).getString("selectField_lajb96un_id");
                System.out.println("是否市外出差id：" + selectField_lajb96un_id);

                //================出差明细的该人员同步状态================
                String textField_lbdexx63 = tableField_lajb96u9.getJSONObject(j).getString("textField_lbdexx63");
                System.out.println("出差明细的该人员同步状态：" + textField_lbdexx63);

                //================岗位补助标准================
                Integer numberField_lajb96um = tableField_lajb96u9.getJSONObject(j).getInteger("numberField_lajb96um");
                System.out.println("岗位补助标准：" + numberField_lajb96um);

                //================唯一标识================
                String textField_lajb96up = tableField_lajb96u9.getJSONObject(j).getString("textField_lajb96up");
                System.out.println("唯一标识：" + textField_lajb96up);

                //================岗位补助标准value值================
                String numberField_lajb96ul_value = tableField_lajb96u9.getJSONObject(j).getString("numberField_lajb96ul_value");
                System.out.println("岗位补助标准value值：" + numberField_lajb96ul_value);

                //================出差明细中的人员姓名================
                String employeeField_lajb96ub = tableField_lajb96u9.getJSONObject(j).getJSONArray("employeeField_lajb96ub").getString(0);
                System.out.println("出差明细中的人员姓名：" + employeeField_lajb96ub);

                //================预计出差天数value值================
                String numberField_lajb96uh_value = tableField_lajb96u9.getJSONObject(j).getString("numberField_lajb96uh_value");
                System.out.println("预计出差天数value值：" + numberField_lajb96uh_value);

                //================实际出差天数value值================
                String numberField_lc460wvs_value = tableField_lajb96u9.getJSONObject(j).getString("numberField_lc460wvs_value");
                System.out.println("实际出差天数value值：" + numberField_lc460wvs_value);

                //================岗位补助标准value值================
                String numberField_lajb96um_value = tableField_lajb96u9.getJSONObject(j).getString("numberField_lajb96um_value");
                System.out.println("岗位补助标准value值：" + numberField_lajb96um_value);

                //================是否市外出差================
                String selectField_lajb96un = tableField_lajb96u9.getJSONObject(j).getString("selectField_lajb96un");
                System.out.println("是否市外出差：" + selectField_lajb96un);

                //================预计出差补贴================
                String numberField_lajb96ul = tableField_lajb96u9.getJSONObject(j).getString("numberField_lajb96ul");
                System.out.println("预计出差补贴：" + numberField_lajb96ul);

                //================实际出差补贴================
                Integer numberField_lc460wvt_value = tableField_lajb96u9.getJSONObject(j).getInteger("numberField_lc460wvt_value");
                System.out.println("实际出差补贴：" + numberField_lc460wvt_value);

                //================预计出差天数================
                String numberField_lajb96uh = tableField_lajb96u9.getJSONObject(j).getString("numberField_lajb96uh");
                System.out.println("预计出差天数：" + numberField_lajb96uh);


                SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                //================出差明细的该人员出差开始时间================
                String dateField_lajb96ud = tableField_lajb96u9.getJSONObject(j).getString("dateField_lajb96ud");
                System.out.println("出差明细中该人员的出差开始时间（毫秒级时间戳）：" + dateField_lajb96ud);
                long startLong = new Long(dateField_lajb96ud);
                //将时间戳转换为时间
                Date startDate = new Date(startLong);
                System.out.println("出差开始时间（时间型）：" + startDate);
                //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
                String startString = simpleDateFormat.format(startDate);
                System.out.println("出差开始时间（时间样式）：" + startString);

                //================出差明细的该人员出差结束时间================
                String dateField_lajb96uf = tableField_lajb96u9.getJSONObject(j).getString("dateField_lajb96uf");
                System.out.println("出差明细中该人员的出差结束时间（毫秒级时间戳）：" + dateField_lajb96uf);
                long endLong = new Long(dateField_lajb96uf);
                //将时间戳转换为时间
                Date endDate = new Date(endLong);
                System.out.println("出差结束时间（时间型）：" + endDate);
                //将时间调整为yyyy-MM-dd HH:mm:ss时间样式
                String endString = simpleDateFormat.format(endDate);
                System.out.println("出差结束时间（时间样式）：" + endString);

                //================当前时间================
                Date dateNow = new Date(System.currentTimeMillis());
                System.out.println("当前时间（时间型）：" + dateNow);
                String dateNowString = simpleDateFormat.format(dateNow);
                System.out.println("当前时间（时间样式）：" + dateNowString);

                //================获取出差结束时间后面一天的零点零分零秒================
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(endDate);
                //后面一天
                calendar.add(Calendar.DAY_OF_MONTH,1);
                calendar.set(Calendar.HOUR_OF_DAY,0);
                calendar.set(Calendar.MINUTE,0);
                calendar.set(Calendar.SECOND,0);
                calendar.set(Calendar.MILLISECOND,0);
                String lastTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
                System.out.println("出差结束时间后面一天零点：" + lastTime);

                //================时间比对================
                //当前时间
                DateTime parseA = DateUtil.parse(dateNowString);
                //出差结束时间后面一天
                DateTime parseB = DateUtil.parse(lastTime);
                //比对两个时间是否属于同一天，属于为true,反之为false
                boolean sameDay = DateUtil.isSameDay(parseA, parseB);
                System.out.println("时间比对结果：" + sameDay);

                //出差明细修改内容：封装每一条明细数据
                Map mapB = new HashMap();

                List listB = new ArrayList();
                listB.add(employeeField_lajb96ub_id);
                System.out.println("封装的出差明细listB：" + listB);
                List listBB = new ArrayList();
                listBB.add(employeeField_lajb96ub);
                System.out.println("封装的出差明细listBB：" + listBB);
//                mapB.put("employeeField_lajb96ub_id",listB);
                mapB.put("selectField_lajb96un_id",selectField_lajb96un_id);
                mapB.put("numberField_lajb96um",numberField_lajb96um);
                mapB.put("dateField_lajb96ud",dateField_lajb96ud);
                mapB.put("textField_lajb96up",textField_lajb96up);
                mapB.put("dateField_lajb96uf",dateField_lajb96uf);
                mapB.put("numberField_lajb96ul_value",numberField_lajb96ul_value);
                mapB.put("employeeField_lajb96ub",listB);
                mapB.put("numberField_lajb96uh_value",numberField_lajb96uh_value);
                mapB.put("numberField_lajb96um_value",numberField_lajb96um_value);
                mapB.put("selectField_lajb96un",selectField_lajb96un);
                mapB.put("numberField_lajb96ul",numberField_lajb96ul);
                mapB.put("numberField_lajb96uh",numberField_lajb96uh);

                //================时间相等（满足执行时间）则去抓取该人员的考勤打卡数据，并将出勤结果同步更新至宜搭================
                if (sameDay == true){
                    //出差实际总天数
                    int ccts = 0;

                    /*查询指定出差申请日期的人员的钉钉考勤打卡*/
                    //待查询人员userid
                    List list = new ArrayList();
                    list.add(employeeField_lajb96ub_id);

                    String body = null;
                    try {
                        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/attendance/list");
                        OapiAttendanceListRequest req = new OapiAttendanceListRequest();
                        //出差开始时间
                        req.setWorkDateFrom(startString);
                        //出差结束时间
                        req.setWorkDateTo(endString);
                        //待查询人员userid
                        req.setUserIdList(list);
                        req.setOffset(0L);
                        req.setLimit(50L);
                        OapiAttendanceListResponse rsp = client.execute(req, accessTokenService.getAccessToken());
                        body = rsp.getBody();
                        System.out.println("打卡结果返回：" + body);
                    } catch (ApiException e) {
                        e.printStackTrace();
                    }

                    JSONObject jsonObjectA = JSON.parseObject(body);
                    JSONArray recordresult = jsonObjectA.getJSONArray("recordresult");
                    int dkcs = 0;
                    for (int a = 0; a < recordresult.size(); a++) {
                        //位置结果：判断是否属于Outside：范围外
                        //Normal：范围内
                        //Outside：范围外
                        //NotSigned：未打卡
                        String result = recordresult.getJSONObject(a).getString("locationResult");
                        System.out.println("打卡位置结果：" + result);
                        if (result.equals("Outside")){
                            dkcs = dkcs + 1;
                        }
                    }
                    System.out.println("符合出差【范围外】打卡次数：" + dkcs);
                    dkcs = dkcs/2;
                    int dkcsLast = (int)dkcs;
                    System.out.println("计算打卡次数换算天数：" + dkcsLast);

                    if (dkcs > 0){
                        //出差实际总天数
                        ccts = ccts + dkcsLast;
                    }
                    System.out.println("出差实际总天数：" + ccts);

                    //计算实际的出差补助（岗位补贴标准*出差实际总天数）
                    int ccbz = numberField_lajb96um * ccts;
                    System.out.println("实际的出差补助：" + ccbz);

                    //实际出差天数
                    mapB.put("numberField_lc460wvs",ccts);
                    //实际出差补助
                    mapB.put("numberField_lc460wvt",ccbz);
                    //是否同步
                    mapB.put("textField_lbdexx63","已同步");

                    listA.add(mapB);

                    mapA.put("tableField_lajb96u9",listA);
                    mapAStr = JSON.toJSONString(mapA);

                    cxsjcb = cxsjcb + ccbz;

                }else {
                    //实际出差天数
                    mapB.put("numberField_lc460wvs",numberField_lc460wvs_value);
                    //实际出差补助
                    mapB.put("numberField_lc460wvt",numberField_lc460wvt_value);
                    //是否同步
                    mapB.put("textField_lbdexx63",textField_lbdexx63);

                    listA.add(mapB);

                    mapA.put("tableField_lajb96u9",listA);
                    mapAStr = JSON.toJSONString(mapA);

                    if (numberField_lc460wvt_value == null || numberField_lc460wvt_value.equals("")){
                        cxsjcb = cxsjcb + 0;
                    }else {
                        cxsjcb = cxsjcb + numberField_lc460wvt_value;
                    }
                }
            }

            System.out.println("封装的出差明细mapAStr：" + mapAStr);

            //更新子表控件数据【全量更新】
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders updateFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders();
                updateFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest updateFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest()
                        .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                        .setFormInstanceId(formInstanceId)
                        .setUserId("yida_pub_account")
                        .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D")
                        .setUpdateFormDataJson(mapAStr);

                client.updateFormDataWithOptions(updateFormDataRequest, updateFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            /*更新主表【出差实际成本】字段*/
            Map mapAll = new HashMap();
            //出差实际成本
            mapAll.put("numberField_lc463l3s",cxsjcb);
            String mapAllStr = JSON.toJSONString(mapAll);
            System.out.println("封装修改的字段参数：" + mapAllStr);

            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders updateFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataHeaders();
                updateFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest updateFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.UpdateFormDataRequest()
                        //应用秘钥
                        .setSystemToken("ETA66681XCH5NWT9CNL9V88ZGIB12I8RTWBALZZE")
                        //表单实例id
                        .setFormInstanceId(formInstanceId)
                        //TODO 系统管理员id
                        .setUserId("yida_pub_account")
                        //应用id
                        .setAppType("APP_UTWSE5WCXGWTUOEJ9E1D")
                        //修改字段
                        .setUpdateFormDataJson(mapAllStr);

                client.updateFormDataWithOptions(updateFormDataRequest, updateFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }
        }

        return "同步【项目预算档案】完成！";
    }
}
